import greenfoot.*;
import java.awt.Color;
import java.awt.Graphics;
import java.awt.Font;

/**
 * Simple Counter class
 * 
 * @author Unknown Author
 * @version Unknown Version
 */
public class Counter extends Actor
{
    private static final Color textColor = new Color(0, 0, 0);
    
    private int value = 0;
    private int target = 0;
    private String text;
    private int stringLength;
    private Font textFont = new Font ("Arial", Font.BOLD, 14);

    public Counter()
    {
        this("");
    }

    public Counter(String prefix)
    {
        text = prefix;
        stringLength = (text.length() + 2) * 10;

        setImage(new GreenfootImage(stringLength, 16));
        GreenfootImage image = getImage();
        image.setColor(textColor);
        image.setFont(textFont);
        updateImage();
    }
    
    public void act() {
        if(value < target) {
            value++;
            updateImage();
        }
        else if(value > target) {
            value--;
            updateImage();
        }
    }
    
    public void setValue(int newValue)
    {
        target = newValue;
        value = newValue;
        updateImage();
    }

    public void add(int score)
    {
        target += score;
    }

    public void subtract(int score)
    {
        target -= score;
    }

    public int getValue()
    {
        return value;
    }

    private void updateImage()
    {
        GreenfootImage image = getImage();
        image.clear();
        image.drawString(text + value, 1, 12);
    }
}