import greenfoot.*;  // (World, Actor, GreenfootImage, Greenfoot and MouseInfo)
import java.awt.Color;
import java.awt.Color;
import java.awt.Point;

/**
 * The initial world that collects input from the user on the number of rings
 * 
 * @author Neil Thistlethwaite
 * @version 1.0
 */

public class InputWorld extends World
{
    TextBox numRings = null;
    Button startButton = null;
    public static int rings = 3;
    public InputWorld()
    {    
        super(600, 400, 1);
        GreenfootImage myImage = new GreenfootImage(600, 400);
        myImage.setColor(new Color(150, 150, 150));
        myImage.fill();
        myImage.setColor(new Color(230, 230, 230));
        myImage.fillRect(50, 50, 500, 300);
        myImage.drawImage(new GreenfootImage("ToHLabel.png"), 150, 100);
        myImage.setColor(new Color(0,0,0));
        myImage.drawString("Number of rings to use: ", 235, 200);
        myImage.drawString("(Maximum is 11)", 253, 217);
        setBackground(myImage);
        startButton = new Button( "Start", new Point(50, 25));
        addObject(startButton, 300, 290);
        numRings = new TextBox(new Point(70, 18), "");
        numRings.setMaxLength(2);
        numRings.acceptOnly("1234567890");
        addObject(numRings, 300, 235);
        Greenfoot.start();

        prepare();
    }

    public void act()
    {
        if(!numRings.getText().equals("")) {
            rings = Integer.parseInt(numRings.getText());
            startButton.setEnable(true);
            if((Integer.parseInt(numRings.getText())>1) && (numRings.getText().length() == 1)) {
                numRings.setMaxLength(1);
                numRings.acceptOnly("1234567890");
            }
            else {
                numRings.setMaxLength(2);
                numRings.acceptOnly("10");
            }
        }
        else {
            //DisableButton
            numRings.acceptOnly("1234567890");
            startButton.setEnable(false);
        }

        if(startButton.wasClicked()) {
            Greenfoot.setWorld(new TowerOfHanoi());
        }

    }

    /**
     * Prepare the world for the start of the program. That is: create the initial
     * objects and add them to the world.
     */
    private void prepare()
    {
    }
}
